automake-patches
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

[PATCH 4/9] New test silentcxx.test (Automake/C++ silent-mode).


From: Stefano Lattarini
Subject: [PATCH 4/9] New test silentcxx.test (Automake/C++ silent-mode).
Date: Mon, 26 Apr 2010 00:00:34 +0200
User-agent: KMail/1.12.1 (Linux/2.6.30-2-686; KDE/4.3.4; i686; ; )

* tests/silentcxx.test: New test.
* tests/Makefile.am (TESTS): Updated accordingly.
From 0d1ddd484c6b08e3136e7f60e6dc6acab5f5d9de Mon Sep 17 00:00:00 2001
From: Stefano Lattarini <address@hidden>
Date: Sun, 25 Apr 2010 22:20:57 +0200
Subject: [PATCH 4/9] New test silentcxx.test (Automake/C++ silent-mode).

* tests/silentcxx.test: New test.
* tests/Makefile.am (TESTS): Updated accordingly.
---
 ChangeLog            |    4 ++
 tests/Makefile.am    |    1 +
 tests/Makefile.in    |    1 +
 tests/silentcxx.test |  105 ++++++++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 111 insertions(+), 0 deletions(-)
 create mode 100755 tests/silentcxx.test

diff --git a/ChangeLog b/ChangeLog
index 71256db..7870466 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,5 +1,9 @@
 2010-04-25  Stefano Lattarini  <address@hidden>
 
+       New test `silentcxx.test' (Automake silent-mode with C++).
+       * tests/silentcxx.test: New test.
+       * tests/Makefile.am (TESTS): Updated accordingly.
+
        New test `silentyacc.test' (Automake silent-mode with Yacc).
        * tests/silentyacc.test: New test.
        * tests/Makefile.am (TESTS): Updated accordingly.
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 600eda6..f2f7fd5 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -624,6 +624,7 @@ silent6.test \
 silent7.test \
 silent8.test \
 silent9.test \
+silentcxx.test \
 silentlex.test \
 silentyacc.test \
 sinclude.test \
diff --git a/tests/Makefile.in b/tests/Makefile.in
index 5fb8bd1..4b8ab84 100644
--- a/tests/Makefile.in
+++ b/tests/Makefile.in
@@ -865,6 +865,7 @@ silent6.test \
 silent7.test \
 silent8.test \
 silent9.test \
+silentcxx.test \
 silentlex.test \
 silentyacc.test \
 sinclude.test \
diff --git a/tests/silentcxx.test b/tests/silentcxx.test
new file mode 100755
index 0000000..aa64d8f
--- /dev/null
+++ b/tests/silentcxx.test
@@ -0,0 +1,105 @@
+#!/bin/sh
+# Copyright (C) 2010 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+# Check silent-rules mode for C++.
+
+required='g++' # FIXME: any decent C++ compiler should be OK
+. ./defs
+
+set -e
+
+mkdir sub
+
+cat >>configure.in <<'EOF'
+AM_SILENT_RULES
+AC_PROG_CXX
+AC_CONFIG_FILES([sub/Makefile])
+AC_OUTPUT
+EOF
+
+cat > Makefile.am <<'EOF'
+# Need generic and non-generic rules.
+bin_PROGRAMS = foo1 foo2
+foo1_SOURCES = foo.cpp baz.cxx quux.cc
+foo2_SOURCES = $(foo1_SOURCES)
+foo2_CXXFLAGS = $(AM_CXXFLAGS)
+SUBDIRS = sub
+EOF
+
+cat > sub/Makefile.am <<'EOF'
+AUTOMAKE_OPTIONS = subdir-objects
+# Need generic and non-generic rules.
+bin_PROGRAMS = bar1 bar2
+bar1_SOURCES = bar.cpp
+bar2_SOURCES = $(bar1_SOURCES)
+bar2_CXXFLAGS = $(AM_CXXFLAGS)
+EOF
+
+cat > foo.cpp <<'EOF'
+using namespace std; /* C compilers fail on this */
+int main() { return 0; }
+EOF
+
+# let's try out other extensions too
+echo 'class Baz  { public: int i;  };' > baz.cxx
+echo 'class Quux { public: bool b; };' > quux.cc
+
+cp foo.cpp sub/bar.cpp
+
+$ACLOCAL
+$AUTOMAKE --add-missing
+$AUTOCONF
+
+# configure once for fastdep, once for non-fastdep, once for nodep
+for config_args in \
+  '' \
+  am_cv_CC_dependencies_compiler_type=gcc \
+  --disable-dependency-tracking
+do
+  ./configure $config_args --enable-silent-rules
+  $MAKE >stdout || { cat stdout; Exit 1; }
+  cat stdout
+
+  $EGREP ' (-c|-o)' stdout && Exit 1
+  grep 'mv ' stdout && Exit 1
+
+  grep 'CXX .*foo\.'  stdout
+  grep 'CXX .*baz\.'  stdout
+  grep 'CXX .*quux\.' stdout
+  grep 'CXX .*bar\.'  stdout
+  grep 'CXXLD .*foo1' stdout
+  grep 'CXXLD .*bar1' stdout
+  grep 'CXXLD .*foo2' stdout
+  grep 'CXXLD .*bar2' stdout
+
+  # Ensure a clean rebuild.
+  $MAKE clean
+
+  $MAKE V=1 >stdout || { cat stdout; Exit 1; }
+  cat stdout
+
+  grep ' -c ' stdout
+  grep ' -o ' stdout
+
+  $EGREP '(CC|CXX|LD) ' stdout && Exit 1
+
+  # Ensure a clean reconfiguration/rebuild.
+  $MAKE clean
+  $MAKE maintainer-clean
+
+done
+
+:
-- 
1.6.5


reply via email to

[Prev in Thread] Current Thread [Next in Thread]